org.apache.groovy.parser.antlr4

## Class TryWithResourcesASTTransformation

- java.lang.Object
- - org.apache.groovy.parser.antlr4.TryWithResourcesASTTransformation

-     public class TryWithResourcesASTTransformation
      extends Object

  Transform try-with-resources to try-catch-finally Reference JLS "14.20.3. try-with-resources"(https://docs.oracle.com/javase/specs/jls/se7/html/jls-14.html)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TryWithResourcesASTTransformation(AstBuilder astBuilder)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Statement` | `transform(TryCatchStatement tryCatchStatement)` Reference JLS "14.20.3.
    `BinaryExpression` | `transformResourceAccess(Expression variableAccessExpression)` See https://docs.oracle.com/javase/specs/jls/se9/html/jls-14.html 14.20.3.1.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TryWithResourcesASTTransformation

          public TryWithResourcesASTTransformation(AstBuilder astBuilder)

  - ### Method Detail

    - #### transform

          public Statement transform(TryCatchStatement tryCatchStatement)

      Reference JLS "14.20.3. try-with-resources"(https://docs.oracle.com/javase/specs/jls/se7/html/jls-14.html)
      Parameters:
        `tryCatchStatement` - the try-with-resources statement to transform
      Returns:
        try-catch-finally statement, which contains no resources clause

    - #### transformResourceAccess

          public BinaryExpression transformResourceAccess(Expression variableAccessExpression)

      See https://docs.oracle.com/javase/specs/jls/se9/html/jls-14.html 14.20.3.1. Basic try-with-resources If a basic try-with-resource statement is of the form: try (VariableAccess ...) Block then the resource is first converted to a local variable declaration by the following translation: try (T #r = VariableAccess ...) { Block }